#include "NiProvider.h"
#include <iostream>

using namespace std;
using namespace thomsonreuters::ema::access;
using namespace thomsonreuters::ema::rdm;
using namespace thomsonreuters::tutorials::ema::nip;

//--------------------------------------------------------------------------------

NiProvider::NiProvider()
{
	cout << "  Provider created" << endl;
}

//--------------------------------------------------------------------------------

NiProvider::~NiProvider()
{
	disconnect();
}

//--------------------------------------------------------------------------------

void NiProvider::connect() 
{

	// Exit the method if already connected
	if (_provider != 0)
		return;

	//const char * host = "YOUR_ADH_IP_ADDRESS:14003";
	const char * host = "10.2.43.49:14003";
	const char * userName = "YOUR_PROVIDER_USER_NAME";

	cout << "  Connecting Provider to ADH " << host << " as " << userName << endl;

	// Connect to the infrastructure using hardcoded parameters
	_provider = new OmmProvider(
						OmmNiProviderConfig()
						.host(host)
						.username(userName));

	// Register the _connectionStateListener to receive login messages from EMA
	_provider->registerClient(
						ReqMsg()
							.domainType(MMT_LOGIN)
							.name(userName),
						_connectionStateListener, 
						(void*)0);
}

//--------------------------------------------------------------------------------

void NiProvider::disconnect()
{
	// Exit the method if already disconnected
	if (_provider == 0)
		return;

	cout << "  Disconnecting..." << endl;

	// Disconnect from the infrastructure and automatically unregister the 
	// _connectionStateListener we registered in the connect() method to 
	// receive login messages from EMA
	delete _provider;
	_provider = 0;
}

//--------------------------------------------------------------------------------

bool NiProvider::isConnected() const
{
	return _connectionStateListener.isConnected();
}

//--------------------------------------------------------------------------------

