#ifndef __ema_tutorial_niprovider_connectionlistener_h_
#define __ema_tutorial_niprovider_connectionlistener_h_

#include "Ema.h"

namespace thomsonreuters
{
namespace tutorials
{
namespace ema
{
namespace nip
{

	//--------------------------------------------------------------------------------
	// This class is responsible for listening to LOGIN events sent by the EMA library. 
	// It defines the methods called by EMA when the provider is connected or 
	// disconnected. It preserves the connection state in memory for later use. 
	class ConnectionStateListener : public thomsonreuters::ema::access::OmmProviderClient
	{

	public:

		ConnectionStateListener();
		virtual ~ConnectionStateListener();

		//--------------------------------------------------------------------------------
		// Returns true is the application is connected to the infrastructure. It returns
		// false otherwise.
		bool isConnected() const;

	private:

		//--------------------------------------------------------------------------------
		// Callback methods declared by thomsonreuters::ema::access::OmmProviderClient
		void onRefreshMsg(const thomsonreuters::ema::access::RefreshMsg&, const thomsonreuters::ema::access::OmmProviderEvent&);
		void onStatusMsg(const thomsonreuters::ema::access::StatusMsg&, const thomsonreuters::ema::access::OmmProviderEvent&);

		//--------------------------------------------------------------------------------
		// Decode and print the connection state
		void decodeConnectionState(const thomsonreuters::ema::access::OmmState & state);

		//--------------------------------------------------------------------------------

		bool _isConnected = false;
	};

}
}
}
}

#endif // __ema_tutorial_niprovider_h_