
#include "ConnectionStateListener.h"
#include <iostream>

using namespace std;
using namespace thomsonreuters::ema::access;
using namespace thomsonreuters::ema::rdm;
using namespace thomsonreuters::tutorials::ema::nip;

//--------------------------------------------------------------------------------

ConnectionStateListener::ConnectionStateListener()
{
}

//--------------------------------------------------------------------------------

ConnectionStateListener::~ConnectionStateListener()
{
}

//--------------------------------------------------------------------------------

bool ConnectionStateListener::isConnected() const
{
	return _isConnected;
}

//--------------------------------------------------------------------------------

void ConnectionStateListener::onRefreshMsg(const RefreshMsg& refreshMsg, const OmmProviderEvent& ommEvent)
{
	decodeConnectionState(refreshMsg.getState());
}

//--------------------------------------------------------------------------------

void ConnectionStateListener::onStatusMsg(const StatusMsg& statusMsg, const OmmProviderEvent& ommEvent)
{
	if (statusMsg.hasState())
	{
		decodeConnectionState(statusMsg.getState());
	}
	else
	{
		cout << "  Provider is connected" << endl;
		_isConnected = true;
	}
}
//--------------------------------------------------------------------------------

void ConnectionStateListener::decodeConnectionState(const thomsonreuters::ema::access::OmmState & state)
{
	if (state.getStreamState() == OmmState::OpenEnum
		&&
		state.getDataState() == OmmState::OkEnum)
	{
		cout << "  Provider is connected. OmmState:" << state << endl; 
		_isConnected = true;
	}
	else
	{
		cout << "  Provider is disconnected. OmmState:" << state << endl;
		_isConnected = false;
	}
}

//--------------------------------------------------------------------------------
